Imports System.IO
Imports System.Text
Imports Newtonsoft.Json

Module Program
    Sub Main(args As String())
        If (args.Length < 1) Then
            Throw New ArgumentException("Aufruf: MusicDB <folder>")
        End If

        ' Musikdateien einlesen...
        Dim discs = New Discs(args(0))

        ' ...oder vom Cache
        Dim json As String
        Dim fileDb = Path.Combine(args(0), "musicDB.json")
        If (Not File.Exists(fileDb)) Then
            discs.Load()
        Else
            Using stream = File.OpenText(fileDb)
                Dim serializer As New JsonSerializer()
                discs = CType(serializer.Deserialize(stream, GetType(Discs)), Discs)
            End Using
        End If

        Console.Write("DiscId eingeben, z.B. 2b0d0717: ")

        Dim discId = Console.ReadLine()
        While discId <> ""
            If String.IsNullOrEmpty(discId) = True Then
                Exit While
            End If

            Dim title = discs.Read(discId)

            If (title Is Nothing) Then
                Console.WriteLine("Titel nicht gefunden!")
            Else
                Console.WriteLine($"{title}\n")
            End If
            discId = Console.ReadLine()
        End While

        json = JsonConvert.SerializeObject(discs)
        File.WriteAllText(fileDb, json, Encoding.UTF8)

    End Sub
End Module
