﻿Imports System.Drawing

Public Class PaintForm
    Private menue As ContextMenuStrip
    Private col As String = "Black"
    Private pen As Pen

    Private isMouseDown As Boolean = False
    Private graphicsBitmap As Graphics
    Private point As Point

    Private cacheBitmap As Bitmap

    Private Sub PaintForm_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        menue = New ContextMenuStrip()
        Dim h As New EventHandler(AddressOf OnMenuClick)

        menue.Items.AddRange(New ToolStripMenuItem() {
                    New ToolStripMenuItem(Color.Black.Name, Nothing, h),
                    New ToolStripMenuItem(Color.Red.Name, Nothing, h),
                    New ToolStripMenuItem(Color.Green.Name, Nothing, h),
                    New ToolStripMenuItem(Color.Blue.Name, Nothing, h),
                    New ToolStripMenuItem(Color.Yellow.Name, Nothing, h)
                    })
        pen = New Pen(System.Drawing.Color.FromName(col), 5)

        ' Cache
        cacheBitmap = New Bitmap(Screen.PrimaryScreen.WorkingArea.Width, Screen.PrimaryScreen.WorkingArea.Height)
        graphicsBitmap = Graphics.FromImage(cacheBitmap)

        ' Trick, um die Aussengrenzen und das Vergrößern des Bildes nicht zu berücksichtigen
        graphicsBitmap.DrawRectangle(New Pen(System.Drawing.Color.FromName("gray"), 1), 0, 0, ClientSize.Width - 1, ClientSize.Height - 1)

    End Sub

    Protected Sub OnMenuClick(sender As Object, e As EventArgs)
        col = DirectCast(sender, ToolStripMenuItem).Text
        pen = New Pen(System.Drawing.Color.FromName(col), 5)
    End Sub

    Private Sub PaintForm_MouseDown(sender As Object, e As MouseEventArgs) Handles MyBase.MouseDown
        If e.Button = MouseButtons.Right Then
            menue.Show(Me, e.Location)
        End If

        If e.Button <> MouseButtons.Left Then
            Return
        End If

        isMouseDown = True

        point = e.Location
    End Sub

    Private Sub PaintForm_MouseMove(sender As Object, e As MouseEventArgs) Handles MyBase.MouseMove
        If isMouseDown = False Then
            Return
        End If

        Using g = CreateGraphics()
            g.DrawLine(pen, point, e.Location)
        End Using

        ' Zeichnen in Bitmap cachen
        graphicsBitmap.DrawLine(pen, point, e.Location)

        point = e.Location
    End Sub

    Private Sub PaintForm_MouseUp(sender As Object, e As MouseEventArgs) Handles MyBase.MouseUp
        isMouseDown = False
    End Sub

    Private Sub PaintForm_Paint(sender As Object, e As PaintEventArgs) Handles MyBase.Paint
        e.Graphics.DrawImage(cacheBitmap, New Point(0, 0))
    End Sub

    Private Sub PaintForm_MouseDoubleClick(sender As Object, e As MouseEventArgs) Handles MyBase.MouseDoubleClick
        Dim c As Cursor = Cursor
        Cursor = Cursors.WaitCursor

        PaintTools.FloodFill(cacheBitmap, e.Location, System.Drawing.Color.FromName(col))
        'PaintTools.FloodFillRecursive(cacheBitmap, e.Location, Color.FromName(color), cacheBitmap.GetPixel(e.Location.X, e.Location.Y))

        Invalidate()
        Cursor = c
    End Sub
End Class
