Imports System.IO
Imports System.Text

Module Program
    Sub Main(args As String())
        Dim output = Console.In

        Console.InputEncoding = Encoding.Default
        Dim spelling = New Spelling(Console.In)

        Dim color = Console.ForegroundColor

        Using stream = New StreamReader(args(0), Encoding.Default)
            Dim text As String = stream.ReadToEnd()

            For Each word As Spelling.Word In spelling.CheckText(text)
                If Not word.IsCorrect Then
                    Console.ForegroundColor = ConsoleColor.Red
                End If

                Console.Write(word.ToString() + " ")

                If Not String.IsNullOrEmpty(word.NearToWord) Then
                    Console.ForegroundColor = ConsoleColor.Green
                    Console.Write("({0}) ", word.NearToWord)
                End If
                Console.ForegroundColor = color
            Next
        End Using
    End Sub
End Module
